//    
import java.awt.*;
import java.awt.event.*;

public class ParamAgent extends Frame
{
	class MainWA extends WindowAdapter
	{
		public void windowClosing(WindowEvent e)
		{
			System.exit(0);
		}
	}

	public ParamAgent()
	{
		super();
		this.addWindowListener(new MainWA());
		initFrame();
		this.show();
		this.setTitle("Control System's Parameters");

		//   
		TextField_N_input.setText(Integer.toString(Param.N_input_Model));
		TextField_N_M.setText(Integer.toString(Param.Nh_M_max));
		TextField_N_C.setText(Integer.toString(Param.Nh_C_max));
		TextField_alfa_M.setText(Double.toString(Param.alfa_Model));
		TextField_alfa_C.setText(Double.toString(Param.alfa_Critic));
		TextField_gamma.setText(Double.toString(Param.gamma));
		TextField_J.setText(Double.toString(Param.J));
		TextField_epsilon.setText(Double.toString(Param.epsilon));
		TextField_k.setText(Double.toString(Param.k));
	}

	public void dispose()
	{
		super.dispose();
	}

	// ,    
	TextField TextField_N_input = new TextField();
	TextField TextField_N_M = new TextField();
	TextField TextField_N_C = new TextField();
	TextField TextField_alfa_M = new TextField();
	TextField TextField_alfa_C = new TextField();
	TextField TextField_gamma = new TextField();
	TextField TextField_J = new TextField();
	TextField TextField_epsilon = new TextField();
	TextField TextField_k = new TextField();

	Label label1 = new Label();
	Label label2 = new Label();
	Label label3 = new Label();
	Label label4 = new Label();
	Label label5 = new Label();
	Label label6 = new Label();
	Label label7 = new Label();
	Label label8 = new Label();
	Label label9 = new Label();

	Button buttonOK = new Button();
	Button buttonCancel = new Button();

	private void initFrame()
	{
		this.setBackground(Color.lightGray);
		this.resize(390, 340);
		this.setResizable(false);
		this.setLayout(null);

		label1.setText("Number of input neurons for Model");
		label1.setBounds(new Rectangle(20, 40, 300, 20));
		label2.setText("Maximum number of hidden neurons for Model");
		label2.setBounds(new Rectangle(20, 65, 300, 20));
		label3.setText("Maximum number of hidden neurons for Critic");
		label3.setBounds(new Rectangle(20, 90, 300, 20));
		label4.setText("Learning coefficient for Model");
		label4.setBounds(new Rectangle(20, 115, 300, 20));
		label5.setText("Learning coefficient for Critic");
		label5.setBounds(new Rectangle(20, 140, 300, 20));
		label6.setText("Discount factor (gamma)");
		label6.setBounds(new Rectangle(20, 165, 300, 20));
		label7.setText("Exchange expenses factor");
		label7.setBounds(new Rectangle(20, 190, 300, 20));
		label8.setText("Parameter for epsilon-greedy rule");
		label8.setBounds(new Rectangle(20, 215, 300, 20));
		label9.setText("Normalizing coefficient");
		label9.setBounds(new Rectangle(20, 240, 300, 20));

		TextField_N_input.setBounds(new Rectangle(320, 40, 50, 20));
		TextField_N_M.setBounds(new Rectangle(320, 65, 50, 20));
		TextField_N_C.setBounds(new Rectangle(320, 90, 50, 20));
		TextField_alfa_M.setBounds(new Rectangle(320, 115, 50, 20));
		TextField_alfa_C.setBounds(new Rectangle(320, 140, 50, 20));
		TextField_gamma.setBounds(new Rectangle(320, 165, 50, 20));
		TextField_J.setBounds(new Rectangle(320, 190, 50, 20));
		TextField_epsilon.setBounds(new Rectangle(320, 215, 50, 20));
		TextField_k.setBounds(new Rectangle(320, 240, 50, 20));

		buttonOK.setLabel("OK");
		buttonOK.setBounds(new Rectangle(90, 290, 80, 25));
		buttonCancel.setLabel("Cancel");
		buttonCancel.setBounds(new Rectangle(220, 290, 80, 25));

		buttonCancel.addActionListener(new java.awt.event.ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				buttonCancel_actionPerformed(e);
			}
		});

		buttonOK.addActionListener(new java.awt.event.ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				buttonOK_actionPerformed(e);
			}
		});

		this.add(label1, null);
		this.add(label2, null);
		this.add(label3, null);
		this.add(label4, null);
		this.add(label5, null);
		this.add(label6, null);
		this.add(label7, null);
		this.add(label8, null);
		this.add(label9, null);

		this.add(TextField_N_input, null);
		this.add(TextField_N_M, null);
		this.add(TextField_N_C, null);
		this.add(TextField_alfa_M, null);
		this.add(TextField_alfa_C, null);
		this.add(TextField_gamma, null);
		this.add(TextField_J, null);
		this.add(TextField_epsilon, null);
		this.add(TextField_k, null);

		this.add(buttonOK, null);
		this.add(buttonCancel, null);
	}

	//   
	void buttonCancel_actionPerformed(ActionEvent e)
	{
		this.dispose();
	}

	//   
	void buttonOK_actionPerformed(ActionEvent e)
	{
		// 
		Param.N_input_Model = (Integer.valueOf(TextField_N_input.getText())).intValue();
		Param.Nh_M_max = (Integer.valueOf(TextField_N_M.getText())).intValue();
		Param.Nh_C_max = (Integer.valueOf(TextField_N_C.getText())).intValue();
		Param.alfa_Model = (Double.valueOf(TextField_alfa_M.getText())).doubleValue();
		Param.alfa_Critic = (Double.valueOf(TextField_alfa_C.getText())).doubleValue();
		Param.gamma = (Double.valueOf(TextField_gamma.getText())).doubleValue();
		Param.J = (Double.valueOf(TextField_J.getText())).doubleValue();		
		Param.epsilon = (Double.valueOf(TextField_epsilon.getText())).doubleValue();		
		Param.k = (Double.valueOf(TextField_k.getText())).doubleValue();
		this.dispose();
	}
}