//  -
//    ,    .
public class Genome
{
	boolean [] hiddenLayer_M = new boolean[Param.Nh_M_max]; //   
	boolean [] hiddenLayer_C = new boolean[Param.Nh_C_max]; //   

	int Nh_M; //    
	int Nh_C; //    

	double [][] WM; //       
	double [] VM; //        
	double [][] WC; //       
	double [] VC; //        

	public Genome() //   .   .
	{
		//    
		Nh_M = 0;
		for(int i = 0; i < Param.Nh_M_max; i++)
		{
			if(Param.rnd.nextDouble() < 0.5)
			{
				hiddenLayer_M[i] = true;
				Nh_M++;
			}
			else
				hiddenLayer_M[i] = false;
		}

		//    
		Nh_C = 0;
		for(int i = 0; i < Param.Nh_C_max; i++)
		{
			if(Param.rnd.nextDouble() < 0.5)
			{
				hiddenLayer_C[i] = true;
				Nh_C++;
			}
			else
				hiddenLayer_C[i] = false;
		}

		//    
		WM = new double [Param.N_input_Model][Nh_M];
		VM = new double [Nh_M];

		for(int j = 0; j < Nh_M; j++)
		{
			VM[j] = Param.rnd.nextGaussian();
			for(int i = 0; i < Param.N_input_Model; i++)
				WM[i][j] = Param.rnd.nextGaussian();
		}
		
		//    	
		WC = new double [2][Nh_C];
		VC = new double [Nh_C];

		for(int j = 0; j < Nh_C; j++)
		{
			VC[j] = Param.rnd.nextGaussian();
			for(int i = 0; i < 2; i++)
				WC[i][j] = Param.rnd.nextGaussian();
		}
	}

	public Genome(Genome a, Genome b) //  .        .
	{
		//   
		WM = new double [Param.N_input_Model][Param.Nh_M_max];
		VM = new double [Param.Nh_M_max];

		//   
		WC = new double [2][Param.Nh_C_max];
		VC = new double [Param.Nh_C_max];

		//     
		int n = 0;
		int ia = 0;
		int ib = 0;
		for(int i = 0; i < Param.Nh_M_max; i++)
		{
			if(Param.rnd.nextDouble() > 0.5)//   
			{
				hiddenLayer_M[i] = a.hiddenLayer_M[i];
				if(a.hiddenLayer_M[i])
				{
					for(int j = 0; j < Param.N_input_Model; j++)
						WM[j][n] = a.WM[j][ia];
					VM[n] = a.VM[ia];
				}
			}
			else//   
			{
				hiddenLayer_M[i] = b.hiddenLayer_M[i];
				if(b.hiddenLayer_M[i])
				{
					for(int j = 0; j < Param.N_input_Model; j++)
						WM[j][n] = b.WM[j][ib];
					VM[n] = b.VM[ib];
				}
			}

			//  
			if(hiddenLayer_M[i])
				n++;
			if(a.hiddenLayer_M[i])//     
				ia++;
			if(b.hiddenLayer_M[i])//     
				ib++;
		}

		//     
		int n1 = 0;//   
		for(int i = 0; i < Param.Nh_M_max; i++)
		{
			if(Param.rnd.nextDouble() < Param.Pb_mut)// 
			{
				if(Param.rnd.nextDouble() > 0.5)// 
				{
					hiddenLayer_M[i] = true;
					for(int j = 0; j < Param.N_input_Model; j++)
						WM[j][n1] = Param.rnd.nextGaussian();

					VM[n1] = Param.rnd.nextGaussian();
				}
				else// 
				{
					hiddenLayer_M[i] = false;
					for(int j = n1; j < n-1; j++)
					{
						for(int k = 0; k < Param.N_input_Model; k++)
							WM[k][j] = WM[k][j+1];
						VM[j] = VM[j+1];
					}
					n--;
				}
			}
			if(hiddenLayer_M[i])//  
				n1++;
		}
		Nh_M = n1;

		//     ,   
		if(Nh_M == 0)
		{
			Nh_M = 1;
			int i1 = (int)Math.floor(Param.Nh_M_max * Param.rnd.nextDouble());
			for(int j = 0; j < Param.N_input_Model; j++)
				WM[j][i1] = Param.rnd.nextGaussian();
			VM[i1] = Param.rnd.nextGaussian();
			hiddenLayer_M[i1] = true;			
		}

		//   
		for(int i = 0; i < Nh_M; i++)
		{
			for(int j = 0; j < Param.N_input_Model; j++)
				WM[j][i] += Param.Pw_mut*Param.rnd.nextGaussian();
			VM[i] += Param.Pw_mut*Param.rnd.nextGaussian();
		}

		//     
		n = 0;
		ia = 0;
		ib = 0;
		for(int i = 0; i < Param.Nh_C_max; i++)
		{
			if(Param.rnd.nextDouble() > 0.5)//   
			{
				hiddenLayer_C[i] = a.hiddenLayer_C[i];
				if(a.hiddenLayer_C[i])
				{
					for(int j = 0; j < 2; j++)
						WC[j][n] = a.WC[j][ia];
					VC[n] = a.VC[ia];
				}
			}
			else//   
			{
				hiddenLayer_C[i] = b.hiddenLayer_C[i];
				if(b.hiddenLayer_C[i])
				{
					for(int j = 0; j < 2; j++)
						WC[j][n] = b.WC[j][ib];
					VC[n] = b.VC[ib];
				}
			}

			//  
			if(hiddenLayer_C[i])
				n++;
			if(a.hiddenLayer_C[i])//     
				ia++;
			if(b.hiddenLayer_C[i])//     
				ib++;
		}

		//   
		n1 = 0;//   
		for(int i = 0; i < Param.Nh_C_max; i++)
		{
			if(Param.rnd.nextDouble() < Param.Pb_mut)// 
			{
				if(Param.rnd.nextDouble() > 0.5)// 
				{
					hiddenLayer_C[i] = true;
					for(int j = 0; j < 2; j++)
						WC[j][n1] = Param.rnd.nextGaussian();

					VC[n1] = Param.rnd.nextGaussian();
				}
				else// 
				{
					hiddenLayer_C[i] = false;
					for(int j = n1; j < n-1; j++)
					{
						for(int k = 0; k < 2; k++)
							WC[k][j] = WC[k][j+1];
						VC[j] = VC[j+1];
					}
					n--;
				}
			}
			if(hiddenLayer_C[i])//  
				n1++;
		}
		Nh_C = n1;

		//     ,   
		if(Nh_C == 0)
		{
			Nh_C = 1;
			int i1 = (int)Math.floor(Param.Nh_C_max * Param.rnd.nextDouble());
			for(int j = 0; j < 2; j++)
				WC[j][i1] = Param.rnd.nextGaussian();
			VC[i1] = Param.rnd.nextGaussian();	
			hiddenLayer_C[i1] = true;		
		}

		//   
		for(int i = 0; i < Nh_C; i++)
		{
			for(int j = 0; j < 2; j++)
				WC[j][i] += Param.Pw_mut*Param.rnd.nextGaussian();
			VC[i] += Param.Pw_mut*Param.rnd.nextGaussian();
		}
	}

	double [] work(double [] input) // ,   
	{
		return null;
	}
}